package org.beangle.model.persist.query;

import org.beangle.commons.collection.page.Page;
import org.beangle.commons.collection.page.SinglePage;
import org.beangle.model.persist.EntityService;
import org.beangle.model.query.AbstractQuery;
import org.beangle.model.query.limit.AbstractQueryPage;

public class QueryPage extends AbstractQueryPage {

	private EntityService entityService;

	public QueryPage(AbstractQuery query, EntityService entityService) {
		super(query);
		this.entityService = entityService;
		next();
	}

	public void setEntityService(EntityService entityService) {
		this.entityService = entityService;
	}

	public Page moveTo(int pageNo) {
		query.getLimit().setPageNo(pageNo);
		setPageData((SinglePage) entityService.search(query));
		return this;
	}
}
